"""
    OrderedSynchronizer(i=1)

A threadsafe synchronizer that allows ensuring concurrent work is done
in a specific order. The `OrderedSynchronizer` is initialized with an
integer `i` that represents the current "order" of the synchronizer.

Work is "scheduled" by calling `put!(f, x, i)`, where `f` is a function
that will be called like `f()` when the synchronizer is at order `i`,
and will otherwise wait until other calls to `put!` have finished
to bring the synchronizer's state to `i`. Once `f()` is called, the
synchronizer's state is incremented by 1 and any waiting `put!` calls
check to see if it's their turn to execute.

A synchronizer's state can be reset to a specific value (1 by default)
by calling `reset!(x, i)`.
"""
mutable struct OrderedSynchronizer
    coordinating_task::Task
    cond::Threads.Condition
    i::Int
@static if VERSION < v"1.7"
    closed::Threads.Atomic{Bool}
else
    @atomic closed::Bool
end
end

@static if VERSION < v"1.7"
OrderedSynchronizer(i=1) = OrderedSynchronizer(current_task(), Threads.Condition(), i, Threads.Atomic{Bool}(false))
else
OrderedSynchronizer(i=1) = OrderedSynchronizer(current_task(), Threads.Condition(), i, false)
end

"""
    reset!(x::OrderedSynchronizer, i=1)

Reset the state of `x` to `i`.
"""
function reset!(x::OrderedSynchronizer, i=1)
    Base.@lock x.cond begin
        x.i = i
@static if VERSION < v"1.7"
        x.closed[] = false
else
        @atomic :monotonic x.closed = false
end
    end
end

function Base.close(x::OrderedSynchronizer, excp::Exception=closed_exception())
    Base.@lock x.cond begin
@static if VERSION < v"1.7"
        x.closed[] = true
else
        @atomic :monotonic x.closed = true
end
        Base.notify_error(x.cond, excp)
    end
    return
end

@static if VERSION < v"1.7"
    Base.isopen(x::OrderedSynchronizer) = !x.closed[]
else
Base.isopen(x::OrderedSynchronizer) = !(@atomic :monotonic x.closed)
end
closed_exception() = InvalidStateException("OrderedSynchronizer is closed.", :closed)

function check_closed(x::OrderedSynchronizer)
    if !isopen(x)
        # if the monotonic load succeed, now do an acquire fence
@static if VERSION < v"1.7"
        !x.closed[] && Base.concurrency_violation()
else
        !(@atomic :acquire x.closed) && Base.concurrency_violation()
end
        throw(closed_exception())
    end
end

"""
    put!(f::Function, x::OrderedSynchronizer, i::Int, incr::Int=1)

Schedule `f` to be called when `x` is at order `i`. Note that `put!`
will block until `f` is executed. The typical usage involves something
like:

```julia
x = OrderedSynchronizer()
@sync for i = 1:N
    Threads.@spawn begin
        # do some concurrent work
        # once work is done, schedule synchronization
        put!(x, \$i) do
            # report back result of concurrent work
            # won't be executed until all `i-1` calls to `put!` have already finished
        end
    end
end
```

The `incr` argument controls how much the synchronizer's state is
incremented after `f` is called. By default, `incr` is 1.
"""
function Base.put!(f, x::OrderedSynchronizer, i, incr=1)
    check_closed(x)
    Base.@lock x.cond begin
        # wait until we're ready to execute f
        while x.i != i
            check_closed(x)
            wait(x.cond)
        end
        check_closed(x)
        try
            f()
        catch e
            Base.throwto(x.coordinating_task, e)
        end
        x.i += incr
        notify(x.cond)
    end
end

using ConcurrentUtilities.Pools, Test

@testset "Pools" begin
    pool_size = length∘Pools.values
    @testset "nonkeyed and pool basics" begin
        pool = Pool{Int}(3)
        @test keytype(pool) === Nothing
        @test valtype(pool) === Int

        @test Pools.limit(pool) == 3
        @test Pools.in_use(pool) == 0
        @test Pools.in_pool(pool) == 0

        # acquire an object from the pool
        x1 = acquire(() -> 1, pool)
        # no existing objects in the pool, so our function was called to create a new one
        @test x1 == 1
        @test Pools.limit(pool) == 3
        @test Pools.in_use(pool) == 1
        @test Pools.in_pool(pool) == 0

        # release back to the pool for reuse
        release(pool, x1)
        @test Pools.in_use(pool) == 0
        @test Pools.in_pool(pool) == 1

        # acquire another object from the pool
        x1 = acquire(() -> 2, pool)
        # this time, the pool had an existing object, so our function was not called
        @test x1 == 1
        @test Pools.in_use(pool) == 1
        @test Pools.in_pool(pool) == 0

        # but now there are no objects to reuse again, so the next acquire will call our function
        x2 = acquire(() -> 2, pool)
        @test x2 == 2
        @test Pools.in_use(pool) == 2
        @test Pools.in_pool(pool) == 0

        x3 = acquire(() -> 3, pool)
        @test x3 == 3
        @test Pools.in_use(pool) == 3
        @test Pools.in_pool(pool) == 0

        # the pool is now at `Pools.limit`, so the next acquire will block until an object is released
        @test Pools.in_use(pool) == Pools.limit(pool)
        tsk = @async acquire(() -> 4, pool; forcenew=true)
        yield()
        @test !istaskdone(tsk)
        # release an object back to the pool
        release(pool, x1)
        # now the acquire can complete
        x1 = fetch(tsk)
        # even though we released 1 for reuse, we passed forcenew, so our function was called to create new
        @test x1 == 4
        @test Pools.in_use(pool) == 3
        @test Pools.in_pool(pool) == 1

        # error to try and provide a key to a non-keyed pool
        @test_throws ArgumentError acquire(() -> 1, pool, 1)

        # release objects back to the pool
        release(pool, x1)
        release(pool, x2)
        release(pool, x3)
        @test Pools.in_use(pool) == 0
        @test Pools.in_pool(pool) == 4

        # acquire an object, but checking isvalid
        x1 = acquire(() -> 5, pool; isvalid=x -> x == 1)
        @test x1 == 1
        @test Pools.in_use(pool) == 1

        # no valid objects, so our function was called to create a new one
        x2 = acquire(() -> 6, pool; isvalid=x -> x == 1)
        @test x2 == 6
        @test Pools.in_use(pool) == 2

        # we have one permit left, we now throw while creating a new object
        # and we want to test that the permit isn't permanently lost for the pool
        @test_throws ErrorException acquire(() -> error("oops"), pool; forcenew=true)
        @test Pools.in_use(pool) == 2

        # throwing while validating a pooled object must also return the permit
        release(pool, x1)
        @test_throws ErrorException acquire(() -> 7, pool; isvalid=_ -> error("invalid"))
        @test Pools.in_use(pool) == 1
        x1 = acquire(() -> 7, pool; forcenew=true)

        # we can still acquire a new object
        x3 = acquire(() -> 7, pool; forcenew=true)
        @test x3 == 7
        @test Pools.in_use(pool) == 3

        # release objects back to the pool
        drain!(pool)
        release(pool, x1)
        release(pool, x2)
        release(pool, x3)
        @test Pools.in_use(pool) == 0
        @test Pools.in_pool(pool) == 3

        # try to do an invalid release
        @test_throws ArgumentError release(pool, 10)

        # test that the invalid release didn't push the object to our pool for reuse
        x1 = acquire(() -> 8, pool)
        @test x1 == 7
        @test Pools.in_use(pool) == 1
        @test Pools.in_pool(pool) == 2
        # calling drain! removes all objects for reuse
        drain!(pool)
        @test Pools.in_use(pool) == 1
        @test Pools.in_pool(pool) == 0

        x2 = acquire(() -> 9, pool)
        @test x2 == 9
        @test Pools.in_use(pool) == 2
        @test Pools.in_pool(pool) == 0
    end

    @testset "keyed pool" begin
        # now test a keyed pool
        pool = Pool{String, Int}(3)
        @test keytype(pool) === String
        @test valtype(pool) === Int

        @test Pools.limit(pool) == 3
        @test Pools.in_use(pool) == 0
        @test Pools.in_pool(pool) == 0

        # acquire an object from the pool
        x1 = acquire(() -> 1, pool, "a")
        # no existing objects in the pool, so our function was called to create a new one
        @test x1 == 1
        @test Pools.in_use(pool) == 1
        @test Pools.in_pool(pool) == 0

        # release back to the pool for reuse
        release(pool, "a", x1)
        @test Pools.in_use(pool) == 0
        @test Pools.in_pool(pool) == 1

        # test for a different key
        x2 = acquire(() -> 2, pool, "b")
        # there's an existing object, but for a different key, so we don't reuse
        @test x2 == 2
        @test Pools.in_use(pool) == 1
        @test Pools.in_pool(pool) == 1

        # acquire another object from the pool
        x1 = acquire(() -> 2, pool, "a")
        # this time, the pool had an existing object, so our function was not called
        @test x1 == 1
        @test Pools.in_use(pool) == 2
        @test Pools.in_pool(pool) == 0

        x3 = acquire(() -> 3, pool, "a")
        @test x3 == 3
        @test Pools.in_use(pool) == 3
        @test Pools.in_pool(pool) == 0

        # the pool is now at capacity, so the next acquire will block until an object is released
        # even though we've acquired using different keys, the capacity is shared across the pool
        @test Pools.in_use(pool) == Pools.limit(pool)
        tsk = @async acquire(() -> 4, pool, "c"; forcenew=true)
        yield()
        @test !istaskdone(tsk)
        # release an object back to the pool
        release(pool, "a", x1)
        # now the acquire can complete
        x1 = fetch(tsk)
        # even though we released 1 for reuse, we passed forcenew, so our function was called to create new
        @test x1 == 4
        @test Pools.in_use(pool) == 3
        @test Pools.in_pool(pool) == 1

        # error to try and provide an invalid key to a keyed pool
        @test_throws ArgumentError acquire(() -> 1, pool, 1)
        @test Pools.in_use(pool) == 3
        @test Pools.in_pool(pool) == 1

        # error to *not* provide a key to a keyed pool
        @test_throws ArgumentError acquire(() -> 1, pool)
        @test Pools.in_use(pool) == 3
        @test Pools.in_pool(pool) == 1

        # error to *not* provide a key when releasing to a keyed pool
        @test_throws ArgumentError release(pool)
        @test Pools.in_use(pool) == 3
        @test Pools.in_pool(pool) == 1

        # error to release an invalid key back to the pool
        @test_throws KeyError release(pool, "z", 1)
        @test_broken Pools.in_use(pool) == 3
        @test Pools.in_pool(pool) == 1
    end
end

"""
  Lockable(value, lock = ReentrantLock())

Creates a `Lockable` object that wraps `value` and
associates it with the provided `lock`.
"""
struct Lockable{T, L <: Base.AbstractLock}
    value::T
    lock::L
end

Lockable(value) = Lockable(value, ReentrantLock())

Base.getindex(l::Lockable) = l.value

"""
  lock(f::Function, l::Lockable)

Acquire the lock associated with `l`, execute `f` with the lock held,
and release the lock when `f` returns. `f` will receive one positional
argument: the value wrapped by `l`. If the lock is already locked by a
different task/thread, wait for it to become available.
When this function returns, the `lock` has been released, so the caller should
not attempt to `unlock` it.
"""
function Base.lock(f, l::Lockable)
    lock(l.lock) do
        f(l.value)
    end
end

# implement the rest of the Lock interface on Lockable
Base.islocked(l::Lockable) = islocked(l.lock)
Base.lock(l::Lockable) = lock(l.lock)
Base.trylock(l::Lockable) = trylock(l.lock)
Base.unlock(l::Lockable) = unlock(l.lock)

using Test, ConcurrentUtilities

@testset "ConcurrentUtilities" begin

    @testset "ConcurrentUtilities.@spawn" begin

        ConcurrentUtilities.init()
        threadid = fetch(ConcurrentUtilities.@spawn(Threads.threadid()))
        @show Threads.nthreads(), threadid
        @test Threads.nthreads() == 1 ? (threadid == 1) : (threadid != 1)
        @test ConcurrentUtilities.@spawn(false, 1 + 1).storage === nothing
        failed = ConcurrentUtilities.@spawn error("expected failure")
        @test_throws TaskFailedException wait(failed)
        @test all(t -> !istaskdone(t), ConcurrentUtilities.WORKER_TASKS)
        @test fetch(ConcurrentUtilities.@spawn(1 + 1)) == 2

    end # @testset "ConcurrentUtilities.@spawn"

    @testset "Lockable" begin
        # Lockable{T, L<:AbstractLock}
        let # test the constructor `Lockable(value, lock)`
            lockable = Lockable(Dict("foo" => "hello"), ReentrantLock())
            @test lockable.value["foo"] == "hello"
            lock(lockable) do d
                @test d["foo"] == "hello"
            end
            lock(lockable) do d
                d["foo"] = "goodbye"
            end
            @test lockable.value["foo"] == "goodbye"
            lock(lockable) do d
                @test d["foo"] == "goodbye"
            end
        end
        let # test the constructor `Lockable(value)`
            lockable = Lockable(Dict("foo" => "hello"))
            @test lockable.value["foo"] == "hello"
            lock(lockable) do d
                @test d["foo"] == "hello"
            end
            lock(lockable) do d
                d["foo"] = "goodbye"
            end
            @test lockable.value["foo"] == "goodbye"
            lock(lockable) do d
                @test d["foo"] == "goodbye"
            end
        end
    end # @testset "Lockable"

    @testset "OrderedSynchronizer" begin

        x = OrderedSynchronizer()
        A = Vector{Int}(undef, 10)
        @sync for i = 10:-1:1
            @async put!(x, i) do
                A[i] = i
            end
        end
        @test A == 1:10

        reset!(x)
        A = Vector{Int}(undef, 10)
        @sync for i = 1:10
            @async put!(x, i) do
                A[i] = i
            end
        end
        @test A == 1:10

        reset!(x)
        A = Vector{Int}(undef, 10)
        @sync for i in (2, 1, 4, 3, 6, 5, 8, 7, 10, 9)
            @async put!(x, i) do
                A[i] = i
            end
        end
        @test A == 1:10

        reset!(x)
        A = Vector{Int}(undef, 4)
        @sync for (i, j) in zip((2, 1, 4, 3), (3, 1, 7, 5))
            @async put!(x, j, 2) do
                A[i] = j
            end
        end
        @test A == [1, 3, 5, 7]

        reset!(x)
        ref = Ref(false)
        ch = Channel(0)
        t = @async begin
            put!(ch, true)
            put!(x, 2) do
                ref[] = true
            end
        end
        # wait until the task is blocked
        take!(ch)
        # test put! hasn't run yet and task isn't done
        @test !ref[]
        @test !istaskdone(t)
        # cancel put! by closing the sync
        close(x)
        e = try
            fetch(t)
        catch e
            e.task.result
        end
        @test e == ConcurrentUtilities.closed_exception()
    end

    @testset "ReadWriteLock" begin
@static if VERSION < v"1.8"
        @warn "skipping ReadWriteLock tests since VERSION ($VERSION) < v\"1.8\""
else
        rw = ReadWriteLock()
        @test rw isa Base.AbstractLock

        @test trylock(rw)
        @test islocked(rw)
        unlock(rw)
        @test !islocked(rw)

        readlock(rw)
        @test islocked(rw)
        @test !trylock(rw)
        @test trylock(() -> error("unreachable"), rw) === false
        @test (@atomic rw.readercount) == 1
        @test (@atomic rw.readerwait) == 0
        readunlock(rw)
        @test !islocked(rw)

        try_result = trylock(rw) do
            @test islocked(rw)
            :write
        end
        @test try_result === :write
        @test !islocked(rw)

        lock(rw)
        @test !trylock(rw)
        @test islocked(rw)
        unlock(rw)
        @test !islocked(rw)
        @test (@atomic rw.readercount) == 0
        @test (@atomic rw.readerwait) == 0

        if Threads.nthreads() > 1
            observed_writer_state = Threads.Atomic{Bool}(false)
            stop_observing = Threads.Atomic{Bool}(false)
            reader_started = Channel(1)
            reader = Threads.@spawn begin
                readlock(rw)
                put!(reader_started, nothing)
                while !stop_observing[]
                    if (@atomic :acquire rw.readercount) < 0
                        observed_writer_state[] = true
                    end
                end
                readunlock(rw)
            end
            take!(reader_started)
            all_failed = all(!trylock(rw) for _ in 1:100_000)
            stop_observing[] = true
            wait(reader)
            @test all_failed
            @test !observed_writer_state[]
            @test (@atomic rw.readerwait) == 0
        end

        if isdefined(Base, :Lockable)
            lockable = Base.Lockable(Ref(1), rw)
            lock(lockable) do value
                value[] += 1
            end
            @test lockable.value[] == 2
        end

        read_result = readlock(rw) do
            @test (@atomic rw.readercount) == 1
            :read
        end
        @test read_result === :read
        @test (@atomic rw.readercount) == 0

        write_result = lock(rw) do
            @test islocked(rw)
            :write
        end
        @test write_result === :write
        @test !islocked(rw)
        @test (@atomic rw.readercount) == 0

        @test_throws ErrorException begin
            readlock(rw) do
                error("read scope failed")
            end
        end
        @test (@atomic rw.readercount) == 0

        @test_throws ErrorException begin
            lock(rw) do
                error("write scope failed")
            end
        end
        @test !islocked(rw)
        @test (@atomic rw.readercount) == 0

        println("test read is blocked while writing")
        lock(rw)
        c = Channel()
        t = @async begin
            put!(c, nothing)
            readlock(rw)
            take!(c)
            readunlock(rw)
            true
        end
        take!(c)
        @test !istaskdone(t)
        unlock(rw)
        @test !istaskdone(t)
        put!(c, nothing)
        @test fetch(t)

        println("test write is blocked until reader done")
        readlock(rw)
        c = Channel()
        t = @async begin
            put!(c, nothing)
            lock(rw)
            take!(c)
            @test islocked(rw)
            unlock(rw)
            true
        end
        take!(c)
        @test !istaskdone(t)
        readunlock(rw)
        @test !istaskdone(t)
        put!(c, nothing)
        @test fetch(t)

        println("test new reads blocked on pending write, and vice versa")
        readlock(rw)
        @test islocked(rw)
        # start another reader
        secondReaderLocked = Ref(false)
        c = Channel()
        r2 = @async begin
            put!(c, nothing)
            readlock(rw)
            secondReaderLocked[] = true
            take!(c)
            readunlock(rw)
            true
        end
        take!(c)
        wc = Channel()
        t = @async begin
            put!(wc, nothing)
            lock(rw)
            take!(wc)
            unlock(rw)
            true
        end
        take!(wc)
        # write task not done
        @test !istaskdone(t)
        # first reader not done
        @test !istaskdone(r2)
        # but first reader did lock
        @test secondReaderLocked[]
        # start a third reader
        thirdReaderLocked = Ref(false)
        c2 = Channel()
        r3 = @async begin
            put!(c2, nothing)
            readlock(rw)
            thirdReaderLocked[] = true
            take!(c2)
            readunlock(rw)
            true
        end
        take!(c2)
        # no tasks have finished yet
        @test !istaskdone(t)
        @test !istaskdone(r2)
        @test !istaskdone(r3)
        # but third reader didn't lock because it's blocked
        # on a _pending_ write
        @test !thirdReaderLocked[]
        # second writer, which should wait til after the already-queued third reader
        wc2 = Channel()
        t2 = @async begin
            put!(wc2, nothing)
            lock(rw)
            take!(wc2)
            unlock(rw)
            true
        end
        take!(wc2)
        # unblock r2
        put!(c, nothing)
        # it should finish
        @test fetch(r2)
        # now unlock 1st reader so write can happen
        readunlock(rw)
        # write task should finish
        put!(wc, nothing)
        @test fetch(t)
        # now that write has finished, r3 should have lock
        put!(c2, nothing)
        @test thirdReaderLocked[]
        @test fetch(r3)
        # only now r3 has finished should t2 have lock
        put!(wc2, nothing)
        @test fetch(t2)
        @test !islocked(rw)

        # A reader released by one writer must not wait behind the next writer,
        # since the next writer includes that reader in readerwait. The reader
        # is descheduled between its readercount increment and its slow path;
        # we replay its steps deterministically.
        rw = ReadWriteLock()
        lock(rw)
        @atomic rw.readercount += 1            # reader R increments, then stalls
        unlock(rw)                             # W1 mints R's release permit
        next_writer = @async begin
            lock(rw)
            unlock(rw)
            true
        end
        while (@atomic rw.readerwait) != 1     # W2 counts R as an active reader
            yield()
        end
        # R resumes its slow path: it must find the permit and proceed
        Base.@lock rw.readwait begin
            @test rw.readerrelease == 1
            rw.readerrelease -= 1
        end
        readunlock(rw)                          # R releases; W2 can proceed
        @test fetch(next_writer)
        @test (@atomic rw.readercount) == 0
        @test (@atomic rw.readerwait) == 0
        @test rw.readerrelease == 0
        @test !islocked(rw)

        # A reader that increments while a later writer is active must wait for
        # that writer even if an earlier writer released other readers in the
        # meantime (regression: a stale snapshot let it slip past the writer).
        rw = ReadWriteLock()
        lock(rw)                                               # W1
        released = @async (readlock(rw); readunlock(rw); true) # pending behind W1
        while (@atomic rw.readercount) != -ConcurrentUtilities.MaxReaders + 1
            yield()
        end
        unlock(rw)                                             # W1 releases it
        @test fetch(released)
        lock(rw)                                               # W2 active
        late_reader = @async (readlock(rw); readunlock(rw); true)
        while (@atomic rw.readercount) != -ConcurrentUtilities.MaxReaders + 1
            yield()
        end
        Base.@lock rw.readwait @test rw.readerrelease == 0     # no leftover permit
        @test !istaskdone(late_reader)
        unlock(rw)                                             # W2 releases it
        @test fetch(late_reader)
        @test (@atomic rw.readercount) == 0
        @test !islocked(rw)

        # A pending reader whose slow-path wait throws while its writer still
        # holds the lock must withdraw its registration.
        rw = ReadWriteLock()
        lock(rw)
        interrupted = @async (readlock(rw); readunlock(rw); true)
        while (@atomic rw.readercount) != -ConcurrentUtilities.MaxReaders + 1
            yield()
        end
        while isempty(rw.readwait.waitq)
            yield()
        end
        Base.@lock rw.readwait notify(rw.readwait, ErrorException("interrupt"), false, true)
        @test_throws TaskFailedException wait(interrupted)
        @test (@atomic rw.readercount) == -ConcurrentUtilities.MaxReaders
        unlock(rw)
        @test (@atomic rw.readercount) == 0
        @test rw.readerrelease == 0
        @test lock(() -> true, rw)
        @test readlock(() -> true, rw)
        @test !islocked(rw)

        # A pending reader whose slow-path wait throws after a writer released
        # it must consume its permit and stand in for the readunlock the next
        # writer is waiting for (replayed deterministically, as above).
        rw = ReadWriteLock()
        lock(rw)
        @atomic rw.readercount += 1            # reader R increments, then stalls
        unlock(rw)                             # W1 mints R's release permit
        next_writer = @async begin
            lock(rw)
            unlock(rw)
            true
        end
        while (@atomic rw.readerwait) != 1
            yield()
        end
        # R's slow path now throws; replay its cleanup
        Base.@lock rw.readwait begin
            @test rw.readerrelease == 1
            rw.readerrelease -= 1
            readunlock(rw)
        end
        @test fetch(next_writer)
        @test (@atomic rw.readercount) == 0
        @test (@atomic rw.readerwait) == 0
        @test rw.readerrelease == 0
        @test !islocked(rw)

        # randomized stress: a writer must never overlap readers or writers
        rw = ReadWriteLock()
        active_readers = Threads.Atomic{Int}(0)
        active_writers = Threads.Atomic{Int}(0)
        violations = Threads.Atomic{Int}(0)
        stress_tasks = Task[]
        for _ in 1:4
            push!(stress_tasks, Threads.@spawn begin
                for _ in 1:250
                    lock(rw)
                    Threads.atomic_add!(active_writers, 1)
                    if active_readers[] != 0 || active_writers[] != 1
                        Threads.atomic_add!(violations, 1)
                    end
                    Threads.atomic_sub!(active_writers, 1)
                    unlock(rw)
                end
            end)
        end
        for _ in 1:8
            push!(stress_tasks, Threads.@spawn begin
                for _ in 1:500
                    readlock(rw)
                    Threads.atomic_add!(active_readers, 1)
                    if active_writers[] != 0
                        Threads.atomic_add!(violations, 1)
                    end
                    Threads.atomic_sub!(active_readers, 1)
                    readunlock(rw)
                end
            end)
        end
        foreach(wait, stress_tasks)
        @test violations[] == 0
        @test (@atomic rw.readercount) == 0
        @test (@atomic rw.readerwait) == 0
        @test rw.readerrelease == 0
        @test !islocked(rw)

@static if isdefined(Base, :CancellationTokenSource)
        # real cancellation of a pending reader
        rw = ReadWriteLock()
        lock(rw)
        source = Base.CancellationTokenSource()
        cancelled = Base.ScopedValues.with(
            () -> Threads.@spawn(readlock(rw)),
            Base.CANCEL_TOKEN => Base.CancellationToken(source),
        )
        while isempty(rw.readwait.waitq)
            yield()
        end
        Base.cancel!(source)
        @test timedwait(() -> istaskdone(cancelled), 5) == :ok
        @test_throws TaskFailedException wait(cancelled)
        @test (@atomic rw.readercount) == -ConcurrentUtilities.MaxReaders
        unlock(rw)
        @test (@atomic rw.readercount) == 0
        @test lock(() -> true, rw)
        @test readlock(() -> true, rw)
        @test !islocked(rw)
end
end # @static if VERSION < v"1.8"
    end

    @testset "FIFOLock" begin
@static if VERSION < v"1.10-"
        @warn "skipping FIFOLock tests since VERSION ($VERSION) < v\"1.10\""
else
        ctr_out = Threads.Atomic{Int}(1)
        test_tasks = Task[]
        sizehint!(test_tasks, 16)
        tasks_out = zeros(Int, 16)
        tot = zeros(Int, 1)
        fl = FIFOLock()
        c = Base.GenericCondition{FIFOLock}(fl)
        lock(c)
        try
            @test notify(c) == 0
        finally
            unlock(c)
        end
        waitq_tail = let fl = fl
            function ()
                c = fl.cond_wait
                lock(c)
                try
                    return c.waitq.tail
                finally
                    unlock(c)
                end
            end
        end
        lock(fl)
        try
            tail = waitq_tail()
            for i in 1:16
                # Queue each task before starting the next one so the FIFO
                # assertion tracks lock wait order, not scheduler timing.
                t = Threads.@spawn begin
                    lock(fl)
                    try
                        tot[1] += 1
                        tasks_out[i] = Threads.atomic_add!(ctr_out, 1)
                    finally
                        unlock(fl)
                    end
                end
                push!(test_tasks, t)
                while waitq_tail() === tail
                    yield()
                end
                tail = waitq_tail()
            end
        finally
            unlock(fl)
        end
        for t in test_tasks
            @test try
                wait(t)
                true
            catch
                false
            end
        end
        @test tot[1] == 16
        @test tasks_out == 1:16

@static if isdefined(Base, :CancellationTokenSource)
        fl = FIFOLock()
        lock(fl)
        source = Base.CancellationTokenSource()
        cancelled = Base.ScopedValues.with(
            () -> Threads.@spawn(lock(fl)),
            Base.CANCEL_TOKEN => Base.CancellationToken(source),
        )
        while isempty(fl.cond_wait)
            yield()
        end
        Base.cancel!(source)
        @test timedwait(() -> istaskdone(cancelled), 5) == :ok
        @test_throws TaskFailedException wait(cancelled)
        unlock(fl)
        @test lock(() -> true, fl)
        @test !islocked(fl)

        # a task that catches the cancellation and keeps running must not be
        # left with finalizers disabled
        lock(fl)
        source = Base.CancellationTokenSource()
        survivor = Base.ScopedValues.with(
            () -> Threads.@spawn(begin
                try
                    lock(fl)
                    false
                catch
                    ccall(:jl_gc_get_finalizers_inhibited, Cint, (Ptr{Cvoid},), C_NULL) == 0
                end
            end),
            Base.CANCEL_TOKEN => Base.CancellationToken(source),
        )
        while isempty(fl.cond_wait)
            yield()
        end
        Base.cancel!(source)
        @test timedwait(() -> istaskdone(survivor), 5) == :ok
        @test fetch(survivor)
        unlock(fl)
        @test lock(() -> true, fl)
        @test !islocked(fl)
end
end # @static if VERSION < v"1.10"
    end

    # track all workers every created
    ALL_WORKERS = []
    ConcurrentUtilities.Workers.GLOBAL_CALLBACK_PER_WORKER[] = w -> push!(ALL_WORKERS, w)
    include("workers.jl")
    # After all tests have run, check we didn't leave any workers running.
    for w in ALL_WORKERS
        if process_running(w.process) || !Workers.terminated(w)
            @show w
        end
        @test !process_running(w.process)
        @test !isopen(w.pipe)
        @test Workers.terminated(w)
        @test istaskstarted(w.messages) && istaskdone(w.messages)
        @test istaskstarted(w.output) && istaskdone(w.output)
        @test istaskstarted(w.worksubmission) && istaskdone(w.worksubmission)
        @test !isopen(w.workqueue)
        @test isempty(w.futures)
    end
    include("pools.jl")
    include("try_with_timeout.jl")
end

    # @testset "@wkspawn" begin
        # basics
        @test fetch(@wkspawn(1 + 1)) == 2
        
        if isdefined(Base.Threads, :maxthreadid)
            # interactive threadpool
            @test fetch(@wkspawn(:interactive, 1 + 1)) == 2
        end
        
        # show incorrect behavior
        ref = Ref(10)
        ansref = Ref(0)
        wkref = WeakRef(ref)
        t = let ref=ref
            Threads.@spawn begin
                ansref[] = $ref[]
            end
        end
        wait(t)
        @test ansref[] == 10
        t = nothing; ref = nothing; GC.gc(true); GC.gc(true); GC.gc(true)
        # Older Julia versions can retain this captured value; newer Julia
        # versions may collect it. `@wkspawn` below should collect it either way.
        base_spawn_value = wkref.value
        @test base_spawn_value === nothing || base_spawn_value.x == 10
        
        # and now with @wkspawn
        ref = Ref(10)
        ansref = Ref(0)
        wkref = WeakRef(ref)
        t = let ref=ref
            @wkspawn begin
                ansref[] = $ref[]
            end
        end
        wait(t)
        @test ansref[] == 10
        t = nothing; ref = nothing; GC.gc(true); GC.gc(true); GC.gc(true)
        @show wkref
        # correctly GCed
        @test wkref.value === nothing

        # captures are also cleared when the spawned expression fails
        ref = Ref(10)
        wkref = WeakRef(ref)
        t = let ref=ref
            @wkspawn begin
                $ref[]
                error("expected failure")
            end
        end
        @test_throws TaskFailedException wait(t)
        @test t.code === nothing
        ref = nothing
        GC.gc(true); GC.gc(true); GC.gc(true)
        @test wkref.value === nothing
#     end

# end # @testset "ConcurrentUtilities"

@static if VERSION >= v"1.10-"

const LOCKED_BIT = 0b01

"""
    FIFOLock()

A reentrant lock similar to Base.ReentrantLock, but with strict FIFO ordering.

Base.ReentrantLock allows tasks to "barge the lock", i.e. it is occasionally
possible for a task to jump the queue of tasks waiting for the lock; this is
intentional behavior to increase throughput as described
[here](https://webkit.org/blog/6161/locking-in-webkit/).

When fairness is more important than throughput, use this FIFOLock.
"""
mutable struct FIFOLock <: AbstractLock
    @atomic locked_by::Union{Task, Nothing}
    reentrancy_cnt::UInt32
    @atomic havelock::UInt8
    cond_wait::Base.ThreadSynchronizer

    FIFOLock() = new(nothing, 0x0000_0000, 0x00, Base.ThreadSynchronizer())
end

assert_havelock(l::FIFOLock) = assert_havelock(l, l.locked_by)
islocked(l::FIFOLock) = (@atomic :monotonic l.havelock) & LOCKED_BIT != 0

# Correctness reasoning:
# 
# `havelock` can only be unset with the `cond_wait` lock held.
# Locking then first tries to set `havelock`; on failure, we
# acquire the `cond_wait` lock and try to set `havelock` again
# to ensure that we didn't coincide with an `unlock`. If we
# fail again, then we are assured that we will not miss an
# `unlock`, because we hold the `cond_wait` lock. Thus we can
# safely wait on `cond_wait`.
#
# FIFO ordering is ensured in `unlock`, which first acquires
# the `cond_wait` lock. If `cond_wait`'s wait queue is empty,
# the lock is released. Otherwise, we pop the first task in
# the wait queue, transfer ownership to it, schedule it, and
# return. Thus when one or more tasks are waiting,`havelock`
# is never reset.

"""
    trylock(l::FIFOLock)

Try to acquire lock `l`. If successful, return `true`. If the lock is
held by another task, do not wait and return `false`. 
"""
@inline function trylock(l::FIFOLock)
    ct = current_task()
    if l.locked_by === ct
        l.reentrancy_cnt += 0x0000_0001
        return true
    end
    return _trylock(l, ct)
end
@noinline function _trylock(l::FIFOLock, ct::Task)
    GC.disable_finalizers()
    if (@atomicreplace :acquire l.havelock 0x00 => LOCKED_BIT).success
        l.reentrancy_cnt = 0x0000_0001
        @atomic :release l.locked_by = ct
        return true
    end
    GC.enable_finalizers()
    return false
end

"""
    lock(l::FIFOLock)

Acquire lock `l`. If the calling task has already acquired the lock
previously, increment an internal counter and return to support
reentrancy. Each `lock` call must be matched with an `unlock` call.

As with `Base.ReentrantLock`, acquiring a lock will inhibit running
finalizers on that thread until the lock is released.

FIFO behavior is handled in `unlock`.
"""
@inline function lock(l::FIFOLock)
    trylock(l) || _lock(l)
end
@noinline function _lock(l::FIFOLock)
    ct = current_task()
    c = l.cond_wait
    lock(c)
    try
        _trylock(l, ct) && return
        GC.disable_finalizers()
        wait(c)
        # l.locked_by and l.reentrancy_cnt are set in unlock
    finally
        unlock(c)
    end
    return
end

"""
    unlock(l::FIFOLock)

Release ownership of the lock `l`. If the lock was acquired recursively,
the number of unlocks must match the number of locks before `l` is
actually released.

FIFO behavior is enforced here, in `unlock`: if one or more tasks are
waiting on the lock, we do not actually unlock; just hand ownership to
the first waiting task and schedule it.
"""
@inline function unlock(l::FIFOLock)
    ct = current_task()
    if l.locked_by !== ct
        error("unlock from wrong thread")
    end
    if l.reentrancy_cnt == 0x0000_0000
        error("unlock count must match lock count")
    end
    _unlock(l)
end
@noinline function _unlock(l::FIFOLock)
    ct = current_task()
    c = l.cond_wait
    n = l.reentrancy_cnt - 0x0000_0001
    if n == 0x0000_0000
        lock(c)
        try
            if isempty(c.waitq)
                l.reentrancy_cnt = n
                @atomic :release l.locked_by = nothing
                @atomic :release l.havelock = 0x00
            else
                t = popfirst!(c.waitq)
                @atomic :release l.locked_by = t
                schedule(t)
                # Leave l.reentrancy_cnt at 1
            end
        finally
            unlock(c)
        end
        GC.enable_finalizers()
    else
        l.reentrancy_cnt = n
    end
    return
end

end

using ConcurrentUtilities, Test

@testset "try_with_timeout" begin
    # test non time out
    @test try_with_timeout(_ -> 1, 1) === 1
    # test time out
    @test_throws TimeoutException try_with_timeout(1) do timedout
        sleep(3)
        # this is a weird place to test, but it _does_
        # print a failure if it doesn't work
        @test timedout[]
    end
    # test exception
    @test_throws ErrorException try
        try_with_timeout(_ -> error("hey"), 1)
    catch e
        @test e isa CapturedException
        rethrow(e.ex)
    end
    # test return type
    @inferred try_with_timeout(_ -> 1, 1, Int)
    # bad return type
    @test_throws TypeError try
        try_with_timeout(_ -> 1, 1, String)
    catch e
        @test e isa CapturedException
        rethrow(e.ex)
    end

    # try_with_timeout should not migrate the task to a different thread pool
    if isdefined(Base.Threads, :threadpool)
        @test try_with_timeout(_ -> Threads.threadpool(), 1) == Threads.threadpool()
        @test read(`julia -t 1,1 -E 'using ConcurrentUtilities; try_with_timeout(_ -> Threads.threadpool(), 1)'`, String) == ":interactive\n"
        @test read(`julia -t 1,1 -E 'using ConcurrentUtilities; fetch(Threads.@spawn begin try_with_timeout(_ -> Threads.threadpool(), 1) end)'`, String) == ":default\n"
    end

    # Make sure the usage of Timer(f, timeout) constructor doesn't sticky the parent task
    t = Threads.@spawn begin
        try_with_timeout(_ -> sleep(1), 2)
    end
    wait(t)
    @test !t.sticky
end

using ConcurrentUtilities.Workers
using Test, IOCapture

@testset "Worker basics" verbose=true begin

    w = Worker()
    @testset "correct connected/running states ($w)" begin
        @test w.pid > 0
        @test process_running(w.process)
        @test isopen(w.pipe)
        @test !Workers.terminated(w)
        background_tasks = (w.messages, w.output, w.worksubmission)
        @test timedwait(() -> all(istaskstarted, background_tasks), 10) == :ok
        @test all(t -> !istaskdone(t), background_tasks)
        @test isempty(w.futures)
    end
    @testset "clean shutdown ($w)" begin
        close(w)
        @test !process_running(w.process)
        @test !isopen(w.pipe)
        @test Workers.terminated(w)
        @test istaskstarted(w.messages) && istaskdone(w.messages)
        @test istaskstarted(w.output) && istaskdone(w.output)
        @test istaskstarted(w.worksubmission) && istaskdone(w.worksubmission)
        @test !isopen(w.workqueue)
        @test isempty(w.futures)
    end

    w = Worker()
    @testset "more forceful shutdown ($w)" begin
        @test w.pid > 0
        terminate!(w)
        wait(w)
        @test !process_running(w.process)
        @test !isopen(w.pipe)
        @test Workers.terminated(w)
        @test istaskstarted(w.messages) && istaskdone(w.messages)
        @test istaskstarted(w.output) && istaskdone(w.output)
        @test istaskstarted(w.worksubmission) && istaskdone(w.worksubmission)
        @test !isopen(w.workqueue)
        @test isempty(w.futures)
    end

    w = Worker()
    @testset "remote_eval/remote_fetch ($w)" begin
        expr = quote
            global x
            x = 101
        end
        ret = remote_fetch(w, expr)
        @test ret == 101
        @test isempty(w.futures) # should be empty since we're not waiting for a response
        # now fetch the remote value
        expr = quote
            global x
            x
        end
        fut = remote_eval(w, expr)
        @test fetch(fut) == 101
        @test isempty(w.futures) # should be empty since we've received all expected responses

        # test remote_call w/ exception
        expr = quote
            error("oops")
        end
        fut = remote_eval(w, expr)
        @test_throws CapturedException fetch(fut)
        close(w)
    end

    # avoid crash logs escaping to stdout, as it confuses PkgEval
    # https://github.com/JuliaTesting/ReTestItems.jl/issues/38
    w = Worker(; worker_redirect_io=devnull)
    @testset "worker crashing ($w)" begin
        expr = quote
            ccall(:abort, Cvoid, ())
        end
        fut = remote_eval(w, expr)
        @test_throws Workers.WorkerTerminatedException fetch(fut)
        wait(w)
        @test !process_running(w.process)
        @test !isopen(w.pipe)
        @test Workers.terminated(w)
        @test istaskstarted(w.messages) && istaskdone(w.messages)
        @test istaskstarted(w.output) && istaskdone(w.output)
        @test istaskstarted(w.worksubmission) && istaskdone(w.worksubmission)
        @test !isopen(w.workqueue)
        @test isempty(w.futures)
        close(w)
    end

    w = Worker()
    @testset "remote_eval ($w)" begin
        fut = remote_eval(w, :(1 + 2))
        @test fetch(fut) == 3
        # test remote module loading
        fut = remote_eval(w, :(using Test; @test 1 == 1))
        @test fetch(fut) isa Test.Pass
        close(w)
    end
end

@testset "Worker connection failure cleanup" begin
    if Sys.isunix()
        mktempdir() do dir
            withenv("TMPDIR" => dir) do
                @test_throws ConcurrentUtilities.TimeoutException Worker(
                    exeflags=`--version`,
                    connect_timeout=1,
                    worker_redirect_io=devnull,
                )
                @test isempty(readdir(dir))
            end
        end
    end
end

@testset "stale response after terminate! does not kill message loop" begin
    w = Worker(worker_redirect_io=devnull)
    fut = remote_eval(w, :(sleep(0.2); 1 + 1))
    while Base.@lock(w.lock, isempty(w.futures))
        yield()
    end
    lock(w.lock)
    # while we hold the coordinator lock, the worker's response arrives and
    # the messages task blocks behind us before it can look up the future
    sleep(1)
    # simulate a concurrent terminate! winning the race to the futures table
    wte = WorkerTerminatedException(w)
    for (_, f) in w.futures
        close(f.value, wte)
    end
    empty!(w.futures)
@static if VERSION < v"1.7"
    w.terminated[] = true
else
    @atomic w.terminated = true
end
    unlock(w.lock)
    @test_throws WorkerTerminatedException fetch(fut)
    # finish what terminate! would have done, then wait for a clean shutdown;
    # the stale response must be dropped rather than kill the messages task
    close(w.workqueue, wte)
    kill(w.process, Base.SIGKILL)
    while !process_exited(w.process)
        sleep(0.1)
    end
    close(w.pipe)
    close(w.server)
    @test wait(w)
    @test istaskstarted(w.messages) && istaskdone(w.messages)
    @test isempty(w.futures)
end

@testset "Workers print in color" begin
    project_path = pkgdir(ConcurrentUtilities)
    code = """
    using ConcurrentUtilities.Workers
    remote_fetch(Worker(), :(printstyled("this better ber red\n", color=:red)))
    """
    # Need to run in a separate process to force --color=yes in CI.
    logs = IOCapture.capture(color=true) do
        run(`$(Base.julia_cmd()) --project=$project_path --color=yes -e $code`)
    end
    @test contains(logs.output,  "\e[31mthis better ber red\e[39m\n")
end

"""
    TimeoutException

Thrown from `try_with_timeout` when the timeout is reached.
"""
struct TimeoutException <: Exception
    timeout::Float64
end

function Base.showerror(io::IO, te::TimeoutException)
    print(io, "TimeoutException: try_with_timeout timed out after $(te.timeout) seconds")
end

"""
    TimedOut

Helper object passed to user-provided `f` in `try_with_timeout`
that allows checking if the calling context reached a time out.
Call `x[]`, which returns a `Bool`, to check if the timeout was reached.
"""
struct TimedOut{T}
    ch::Channel{T}
end

Base.getindex(x::TimedOut) = !isopen(x.ch)

"""
    try_with_timeout(f, timeout, T=Any) -> T

Run `f` in a new task, and return its result. If `f` does not complete within
`timeout` seconds, throw a `TimeoutException`. If `f` throws an exception, rethrow
it. If `f` completes successfully, return its result.
`f` should be of the form `f(x::TimedOut)`, where `x` is a `TimedOut` object.
This allows the calling function to check whether the timeout has been reached
by checking `x[]` and if `true`, the timeout was reached and the function can
cancel/abort gracefully. The 3rd argument `T` is optional (default `Any`) and
allows passing an expected return type that `f` should return; this allows avoiding
a dynamic dispatch from non-inferability of using `try_with_timeout` with `f`.

# Examples

```julia
julia> try_with_timeout(_ -> 1, 1)
1

julia> try_with_timeout(_ -> sleep(3), 1)
ERROR: TimeoutException: try_with_timeout timed out after 1.0 seconds
Stacktrace:
 [1] try_with_timeout(::var"#1#2", ::Int64) at ./REPL[1]:1
 [2] top-level scope at REPL[2]:1

julia> try_with_timeout(_ -> error("hey"), 1)
ERROR: hey
Stacktrace:
 [1] error(::String) at ./error.jl:33
 [2] (::var"#1#2")(::TimedOut{Any}) at ./REPL[1]:1
 [3] try_with_timeout(::var"#1#2", ::Int64) at ./REPL[1]:1
 [4] top-level scope at REPL[3]:1

julia> try_with_timeout(_ -> 1, 1, Int)
1

# usage with `TimedOut`
julia> try_with_timeout(1) do timedout
    while !timedout[]
        # do iterative computation that may take too long
    end
end

julia> try_with_timeout(1) do timedout
    sleep(3)
    timedout[] && abort_gracefully()
end
```
"""
function try_with_timeout(f, timeout, ::Type{T}=Any) where {T}
    ch = Channel{T}(0)
    timer = Timer(timeout)
    @samethreadpool_spawn begin
        _ch = $ch
        try
            wait($timer)
            !isready(_ch) && close(_ch, TimeoutException($timeout))
        catch e
            e isa EOFError || close(_ch, CapturedException(e, catch_backtrace()))
        end
    end
    @samethreadpool_spawn begin
        _ch = $ch
        x = TimedOut(_ch)
        try
            put!(_ch, $(f)(x)::T)
        catch e
            close(_ch, CapturedException(e, catch_backtrace()))
        finally
            close($timer)
        end
    end
    return take!(ch)
end

@static if VERSION >= v"1.8"

"""
    ReadWriteLock()

A threadsafe lock that allows multiple readers or a single writer.

The read side is acquired/released via `readlock(rw)` and `readunlock(rw)`,
while the write side is acquired/released via `lock(rw)`, `trylock(rw)`, and
`unlock(rw)`.
Use `readlock(rw) do ... end` or `lock(rw) do ... end` to scope lock
ownership to a function call.

While a writer is active, all readers will block. Once the writer is finished,
all pending readers will be allowed to acquire/release before the next writer.
"""
mutable struct ReadWriteLock <: Base.AbstractLock
    writelock::ReentrantLock
    readwait::Threads.Condition
    writeready::Threads.Event
    # `readercount` keeps track of how many readers are active or pending
    # if > 0, then that's the number of active readers
    # if < 0, then there is a writer active or pending, and
    # `readercount + MaxReaders` is the number of active or pending readers
    @atomic readercount::Int
    @atomic readerwait::Int
    # number of pending readers released by a writer's unlock that have not
    # resumed yet; guarded by the lock of `readwait`
    readerrelease::Int
end

function ReadWriteLock()
@static if VERSION < v"1.8"
    throw(ArgumentError("ReadWriteLock requires Julia v1.8 or greater"))
else
    return ReadWriteLock(ReentrantLock(), Threads.Condition(), Threads.Event(true), 0, 0, 0)
end
end

const MaxReaders = 1 << 30

function readlock(rw::ReadWriteLock)
    # first step is to increment readercount atomically
    if (@atomic :acquire_release rw.readercount += 1) < 0
        # if we observe from our atomic operation that readercount is < 0,
        # a writer was active or pending, so we need initiate the "slowpath"
        # by acquiring the readwait lock
        try
            Base.@lock rw.readwait begin
                # An unlocking writer mints one release permit per pending
                # reader it releases (`readerrelease`); each pending reader
                # consumes exactly one permit before acquiring the read side.
                # Permits are fungible: one minted for a slow-to-resume reader
                # may be consumed by another pending reader, which then stands
                # in for it in the next writer's `readerwait` count. Counting
                # permits (rather than re-checking `readercount`, which a
                # later writer can make negative again) ensures a reader can
                # neither deadlock behind a writer that already counted it as
                # active nor slip past a writer that did not release it.
                while rw.readerrelease == 0
                    wait(rw.readwait)
                end
                rw.readerrelease -= 1
            end
        catch
            Base.@lock rw.readwait begin
                if rw.readerrelease > 0
                    # A writer's unlock already released a pending reader:
                    # consume one permit as if we briefly held the read side,
                    # and release it. If the permit was minted for another
                    # reader, that reader is simply released by a later
                    # writer's unlock instead (which still counts it).
                    rw.readerrelease -= 1
                    readunlock(rw)
                else
                    # No writer has released us: withdraw our pending reader
                    # registration. Permits are minted under the readwait lock
                    # we hold, so no unlocking writer can count us concurrently.
                    @atomic :acquire_release rw.readercount -= 1
                end
            end
            rethrow()
        end
    end
    return
end

"""
    readlock(f, rw::ReadWriteLock)

Acquire the read side of `rw`, execute `f`, and release the read side when `f`
returns or throws.
"""
function readlock(f, rw::ReadWriteLock)
    readlock(rw)
    try
        return f()
    finally
        readunlock(rw)
    end
end

function readunlock(rw::ReadWriteLock)
    # similar to `readlock`, the first step is to decrement `readercount` atomically
    if (@atomic :acquire_release rw.readercount -= 1) < 0
        # if we observe from our atomic operation that readercount is < 0,
        # there's a pending write, so check if we're the last reader
        if (@atomic :acquire_release rw.readerwait -= 1) == 0
            # we observed that there was a pending write AND we just
            # observed that we were the last reader, so it's our
            # responsibility to notify the writer that it can proceed
            notify(rw.writeready)
        end
    end
    return
end

function Base.lock(rw::ReadWriteLock)
    lock(rw.writelock) # only a single writer allowed at a time
    # first, we subtract MaxReaders from readercount
    # to make readercount negative; this will prevent any further readers
    # from locking, while maintaining our actual reader count so we
    # can track when we're able to write
    r = (@atomic :acquire_release rw.readercount -= MaxReaders) + MaxReaders
    # we also _add_ MaxReaders so that `r` is the number of active readers
    # if r == 0, that means there were no readers,
    # so we can proceed directly with the write lock (the 1st check below in the if)
    # if there _are_ active readers, then we need to wait until they all unlock
    # by incrementing `readerwait` by `r`, we're atomically setting the # of read
    # unlocks we expect to happen before we can proceed with the write lock
    # (readers decrement `readerwait` if they observe `readercount` is negative)
    # if, by chance, the last reader manages to unlock before we increment `readerwait`,
    # then `readerwait` will actually be negative and we'll increment it back to 0
    # in that case, we can proceed directly with the write lock (the 2nd check below)
    if r != 0 && (@atomic :acquire_release rw.readerwait += r) != 0
        # otherwise, there are still pending readers, so we need to wait for them to finish
        # we do this by waiting on the `writeready` event, which will be
        # notified when the last reader unlocks; if the last reader happens
        # to be racing with us, then `writeready` will already be set and
        # we'll proceed immediately
        wait(rw.writeready)
    end
    return
end

"""
    trylock(rw::ReadWriteLock)

Attempt to acquire the write side of `rw` without blocking. Return `true` on
success and `false` if either the read or write side is already held.
"""
function Base.trylock(rw::ReadWriteLock)
    trylock(rw.writelock) || return false
    result = @atomicreplace :acquire_release :acquire rw.readercount 0 => -MaxReaders
    result.success || unlock(rw.writelock)
    return result.success
end

"""
    lock(f, rw::ReadWriteLock)

Acquire the write side of `rw`, execute `f`, and release the write side when
`f` returns or throws.
"""
function Base.lock(f, rw::ReadWriteLock)
    lock(rw)
    try
        return f()
    finally
        unlock(rw)
    end
end

"""
    islocked(rw::ReadWriteLock)

Return `true` if either the read or write side of `rw` is held.
"""
function Base.islocked(rw::ReadWriteLock)
    return islocked(rw.writelock) || (@atomic :monotonic rw.readercount) != 0
end

function Base.unlock(rw::ReadWriteLock)
    # flip the `readercount` sign back under the readwait lock, so that permit
    # minting is atomic with respect to a cancelled reader withdrawing its
    # registration (see the catch block in `readlock`)
    Base.@lock rw.readwait begin
        r = (@atomic :acquire_release rw.readercount += MaxReaders)
        if r > 0
            # mint one release permit per pending reader and wake them up
            rw.readerrelease += r
            notify(rw.readwait)
        end
    end
    unlock(rw.writelock)
    return
end

end

module Workers

using Sockets, Serialization

export Worker, remote_eval, remote_fetch, terminate!, WorkerTerminatedException

import ..try_with_timeout

# RPC framework
struct Request
    mod::Symbol # module in which we should eval
    expr::Expr # expression to eval
    id::UInt64 # unique id for this request
    # if true, worker should terminate immediately after receiving this Request
    # ignoring other fields
    shutdown::Bool
end

# worker executes Request and returns a serialized Response object *if* Request wasn't a shutdown
struct Response
    result
    error::Union{Nothing, Exception}
    id::UInt64 # matches a corresponding Request.id
end

# simple FutureResult that coordinator can wait on until a Response comes back for a Request
struct FutureResult
    id::UInt64 # matches a corresponding Request.id
    value::Channel{Any} # size 1
end

Base.fetch(f::FutureResult) = fetch(f.value)

mutable struct Worker
    lock::ReentrantLock # protects the .futures field; no other fields are modified after construction
    pid::Int
    process::Base.Process
    server::Sockets.PipeServer
    pipe::Base.PipeEndpoint
    messages::Task
    output::Task
    process_watch::Task
    worksubmission::Task
    workqueue::Channel{Tuple{Request, FutureResult}}
    futures::Dict{UInt64, FutureResult} # Request.id -> FutureResult
@static if VERSION < v"1.7"
    terminated::Threads.Atomic{Bool}
else
    @atomic terminated::Bool
end
end

# used to close FutureResult.value channels when a worker terminates
struct WorkerTerminatedException <: Exception
    worker::Worker
end

# atomics compat
macro atomiccas(ex, cmp, val)
    @static if VERSION < v"1.7"
        return esc(quote
            _ret = Threads.atomic_cas!($ex, $cmp, $val)
            (; success=(_ret === $cmp))
        end)
    else
        return esc(:(@atomicreplace $ex $cmp => $val))
    end
end

macro atomicget(ex)
    @static if VERSION < v"1.7"
        return esc(Expr(:ref, ex))
    else
        return esc(:(@atomic :acquire $ex))
    end
end

terminated(w::Worker) = @atomicget(w.terminated)

# performs all the "closing" tasks of worker fields
# but does not *wait* for a final close state
# so typically callers should call wait(w) after this
function terminate!(w::Worker, from::Symbol=:manual)
    if @atomiccas(w.terminated, false, true).success
        # we won getting to close down the worker
        @debug "terminating worker $(w.pid) from $from"
        wte = WorkerTerminatedException(w)
        Base.@lock w.lock begin
            for (_, fut) in w.futures
                close(fut.value, wte)
            end
            empty!(w.futures)
        end
        signal = Base.SIGTERM
        while true
            kill(w.process, signal)
            signal = signal == Base.SIGTERM ? Base.SIGINT : Base.SIGKILL
            process_exited(w.process) && break
            sleep(0.1)
            process_exited(w.process) && break
        end
        close(w.pipe)
        close(w.server)
    end
    return
end

# Base.Process has a nifty .exitnotify Condition
# so we might as well get notified when the process exits
# as one of our ways of detecting the worker has gone away
function watch_and_terminate!(w::Worker)
    wait(w.process)
    terminate!(w, :watch_and_terminate)
    true
end

# gracefully terminate a worker by sending a shutdown message
# and waiting for the other tasks to perform worker shutdown
function Base.close(w::Worker)
    if !terminated(w) && isopen(w.pipe)
        req = Request(Symbol(), :(), rand(UInt64), true)
        Base.@lock w.lock begin
            serialize(w.pipe, req)
        end
    end
    wait(w)
    return
end

# wait until our spawned tasks have all finished
Base.wait(w::Worker) = fetch(w.process_watch) && fetch(w.messages) && fetch(w.output)

Base.show(io::IO, w::Worker) = print(io, "Worker(pid=$(w.pid)", terminated(w) ? ", terminated=true, termsignal=$(w.process.termsignal)" : "", ")")

# used in testing to ensure all created workers are
# eventually cleaned up properly
const GLOBAL_CALLBACK_PER_WORKER = Ref{Any}()

function Worker(;
    env::AbstractDict=ENV,
    dir::String=pwd(),
    threads::String="auto",
    exeflags=`--threads=$threads`,
    connect_timeout::Int=60,
    worker_redirect_io::IO=stdout,
    worker_redirect_fn=(io, pid, line)->println(io, "  Worker $pid:  $line")
    )
    # below copied from Distributed.launch
    env = Dict{String, String}(env)
    pathsep = Sys.iswindows() ? ";" : ":"
    if get(env, "JULIA_LOAD_PATH", nothing) === nothing
        env["JULIA_LOAD_PATH"] = join(LOAD_PATH, pathsep)
    end
    if get(env, "JULIA_DEPOT_PATH", nothing) === nothing
        env["JULIA_DEPOT_PATH"] = join(DEPOT_PATH, pathsep)
    end
    # Set the active project on workers using JULIA_PROJECT.
    # Users can opt-out of this by (i) passing `env = ...` or (ii) passing
    # `--project=...` as `exeflags` to addprocs(...).
    project = Base.ACTIVE_PROJECT[]
    if project !== nothing && get(env, "JULIA_PROJECT", nothing) === nothing
        env["JULIA_PROJECT"] = project
    end
    # end copied from Distributed.launch
    # Ensure the subprocess can find ConcurrentUtilities via the package system.
    # The parent project may only have it as a transitive dep, so we add the
    # ConcurrentUtilities project dir to the load path.
    cu_project_dir = dirname(@__DIR__)
    lp = get(env, "JULIA_LOAD_PATH", "")
    if !occursin(cu_project_dir, lp)
        env["JULIA_LOAD_PATH"] = cu_project_dir * pathsep * lp
    end
    ## start the worker process
    file = tempname()
    server = Sockets.listen(file)
    color = get(worker_redirect_io, :color, false) ? "yes" : "no" # respect color of target io
    exec = "using ConcurrentUtilities: Workers; Workers.startworker(\"$file\")"
    cmd = `$(Base.julia_cmd()) $exeflags --startup-file=no --color=$color -e $exec`
    proc = open(detach(setenv(addenv(cmd, env), dir=dir)), "r+")
    pid = Libc.getpid(proc)

    ## connect to the worker process with timeout
    try
        pipe = try_with_timeout(x -> Sockets.accept(server), connect_timeout)
        # create worker
@static if VERSION < v"1.7"
        w = Worker(ReentrantLock(), pid, proc, server, pipe, Task(nothing), Task(nothing), Task(nothing), Task(nothing), Channel{Tuple{Request, FutureResult}}(), Dict{UInt64, FutureResult}(), Threads.Atomic{Bool}(false))
else
        w = Worker(ReentrantLock(), pid, proc, server, pipe, Task(nothing), Task(nothing), Task(nothing), Task(nothing), Channel{Tuple{Request, FutureResult}}(), Dict{UInt64, FutureResult}(), false)
end
        ## start a task to watch for worker process termination
        w.process_watch = Threads.@spawn watch_and_terminate!(w)
        ## start a task to redirect worker output
        w.output = Threads.@spawn redirect_worker_output(worker_redirect_io, w, worker_redirect_fn, proc)
        ## start a task to listen for worker messages
        w.messages = Threads.@spawn process_responses(w)
        ## start a task to process eval requests and send to worker
        w.worksubmission = Threads.@spawn process_work(w)
        # add a finalizer
        finalizer(x -> @async(terminate!(x, :finalizer)), w) # @async to allow a task switch
        if isassigned(GLOBAL_CALLBACK_PER_WORKER)
            GLOBAL_CALLBACK_PER_WORKER[](w)
        end
        return w
    catch
        # cleanup in case connect fails/times out
        kill(proc, Base.SIGKILL)
        @isdefined(sock) && close(sock)
        @isdefined(w) && terminate!(w, :Worker_catch)
        rethrow()
    end
end

function redirect_worker_output(io::IO, w::Worker, fn, proc)
    try
        while !process_exited(proc) && !@atomicget(w.terminated)
            line = readline(proc)
            if !isempty(line)
                fn(io, w.pid, line)
                flush(io)
            end
        end
    catch e
        # @error "Error redirecting worker output $(w.pid)" exception=(e, catch_backtrace())
        terminate!(w, :redirect_worker_output)
        e isa EOFError || e isa Base.IOError || rethrow()
    end
    true
end

function process_responses(w::Worker)
    lock = w.lock
    reqs = w.futures
    try
        while isopen(w.pipe) && !@atomicget(w.terminated)
            # get the next Response from the worker
            r = deserialize(w.pipe)
            @assert r isa Response "Received invalid response from worker $(w.pid): $(r)"
            # println("Received response $(r) from worker $(w.pid)")
            Base.@lock lock begin
                # look up the FutureResult for this request
                fut = pop!(reqs, r.id)
                @assert !isready(fut.value) "Received duplicate response for request $(r.id) from worker $(w.pid)"
                if r.error !== nothing
                    # this allows rethrowing the exception from the worker to the caller
                    close(fut.value, r.error)
                else
                    put!(fut.value, r.result)
                end
            end
        end
    catch e
        # @error "Error processing responses from worker $(w.pid)" exception=(e, catch_backtrace())
        terminate!(w, :process_responses)
        e isa EOFError || e isa Base.IOError || rethrow()
    end
    true
end

function process_work(w::Worker)
    try
        for (req, fut) in w.workqueue
            # println("Sending request $(req) to worker $(w.pid)")
            Base.@lock w.lock begin
                w.futures[req.id] = fut
            end
            serialize(w.pipe, req)
        end
    catch e
        # @error "Error processing work for worker $(w.pid)" exception=(e, catch_backtrace())
        terminate!(w, :process_work)
        # e isa EOFError || e isa Base.IOError || rethrow()
    end
end

remote_eval(w::Worker, expr) = remote_eval(w, Main, expr.head == :block ? Expr(:toplevel, expr.args...) : expr)

function remote_eval(w::Worker, mod, expr)
    terminated(w) && throw(WorkerTerminatedException(w))
    # we only send the Symbol module name to the worker
    req = Request(nameof(mod), expr, rand(UInt64), false)
    fut = FutureResult(req.id, Channel(1))
    put!(w.workqueue, (req, fut))
    return fut
end

# convenience call to eval and fetch in one step
remote_fetch(w::Worker, args...) = fetch(remote_eval(w, args...))

# compat for `Threads.@spawn :interactive expr`
@static if hasmethod(getfield(Threads, Symbol("@spawn")), Tuple{LineNumberNode, Module, Symbol, Expr})
    macro _spawn_interactive(ex)
        esc(:(Threads.@spawn :interactive $ex))
    end
else
    macro _spawn_interactive(ex)
        esc(:(@async $ex))
    end
end

function startworker(file)
    # don't need stdin (copied from Distributed.start_worker)
    redirect_stdin(devnull)
    close(stdin)
    redirect_stderr(stdout) # redirect stderr so coordinator reads everything from stdout
    pipe = Sockets.connect(file)
    try
        wait(@_spawn_interactive serve_requests(pipe))
    catch e
        @error "Error serving requests from coordinator" exception=(e, catch_backtrace())
    finally
        close(pipe)
        exit(0)
    end
end

# we need to lookup the module to eval in for this request
# so we loop through loaded modules until we find it
function getmodule(nm::Symbol)
    # fast-path Main/Base/Core
    nm == :Main && return Main
    nm == :Base && return Base
    nm == :Core && return Core
    for mod in Base.loaded_modules_array()
        if nameof(mod) == nm
            return mod
        end
    end
    error("module $nm not found")
end

function execute(r::Request)
    # @show r.mod, r.expr
    return Core.eval(getmodule(r.mod), r.expr)
end

function serve_requests(io)
    iolock = ReentrantLock()
    while true
        req = deserialize(io)
        @assert req isa Request
        req.shutdown && break
        # println("received request: $(req)")
        Threads.@spawn begin
            r = $req
            local resp
            try
                result = execute(r)
                resp = Response(result, nothing, r.id)
            catch e
                resp = Response(nothing, CapturedException(e, catch_backtrace()), r.id)
            finally
                Base.@lock iolock begin
                    # println("sending response: $(resp)")
                    serialize(io, resp)
                end
            end
        end
        yield()
    end
end

end # module Workers

module Pools

export Pool, acquire, release, drain!
import Base: acquire, release

"""
    Pool{T}(limit::Int=4096)
    Pool{K, T}(limit::Int=4096)

A threadsafe object for managing a pool of objects of type `T`, optionally keyed by objects
of type `K`.

Objects can be requested by calling `acquire(f, pool, [key])`, where `f` is a
function that returns a new object of type `T`.
The `key` argument is optional and can be used to lookup objects that match a certain criteria
(a `Dict` is used internally, so matching is `isequal`).

The `limit` argument will limit the number of objects that can be in use at any given time.
If the limit has been reached, `acquire` will block until an object is released
via `release`.

- `release(pool, obj)` will return the object to the pool for reuse.
- `release(pool)` will decrement the number in use but not return any object for reuse.
- `drain!` can be used to remove objects that have been returned to the pool for reuse;
  it does *not* release any objects that are in use.

See also `acquire`, `release`, `Pools.limit`, `Pools.in_use`, `Pools.in_pool`, `drain!`.
The key and object types can be inspected with `keytype` and `valtype` respectively.
"""
mutable struct Pool{K, T}
    lock::Threads.Condition
    limit::Int
    cur::Int
    keyedvalues::Dict{K, Vector{T}}
    values::Vector{T}

    function Pool{K, T}(limit::Int=4096) where {K, T}
        T === Nothing && throw(ArgumentError("Pool type can not be `Nothing`"))
        x = new(Threads.Condition(), limit, 0)
        if K === Nothing
            x.values = T[]
            safesizehint!(x.values, limit)
        else
            x.keyedvalues = Dict{K, Vector{T}}()
        end
        return x
    end
end

Pool{T}(limit::Int=4096) where {T} = Pool{Nothing, T}(limit)

safesizehint!(x, n) = sizehint!(x, min(4096, n))

# determines whether we'll look up object caches in .keyedvalues or .values
iskeyed(::Pool{K}) where {K} = K !== Nothing

"""
    keytype(::Pool)

Return the type of the keys for the pool.
If the pool is not keyed, this will return `Nothing`.
"""
Base.keytype(::Type{<:Pool{K}}) where {K} = K
Base.keytype(p::Pool) = keytype(typeof(p))

"""
    valtype(::Pool)

Return the type of the objects that can be stored in the pool.
"""
Base.valtype(::Type{<:Pool{<:Any, T}}) where {T} = T
Base.valtype(p::Pool) = valtype(typeof(p))

"""
    Pools.limit(pool::Pool) -> Int

Return the maximum number of objects permitted to be in use at the same time.
See `Pools.in_use(pool)` for the number of objects currently in use.
"""
limit(pool::Pool) = Base.@lock pool.lock pool.limit

"""
    Pools.in_use(pool::Pool) -> Int

Return the number of objects currently in use. Less than or equal to `Pools.limit(pool)`.
"""
in_use(pool::Pool) = Base.@lock pool.lock pool.cur

"""
    Pools.in_pool(pool::Pool) -> Int

Return the number of objects in the pool available for reuse.
"""
in_pool(pool::Pool) = Base.@lock pool.lock mapreduce(length, +, values(pool.keyedvalues); init=0)
in_pool(pool::Pool{Nothing}) = Base.@lock pool.lock length(pool.values)

"""
    drain!(pool)

Remove all objects from the pool for reuse, but do not release any active acquires.
"""
function drain!(pool::Pool{K}) where {K}
    Base.@lock pool.lock begin
        if iskeyed(pool)
            for objs in values(pool.keyedvalues)
                empty!(objs)
            end
        else
            empty!(pool.values)
        end
    end
end

# in VERSION >= v"1.7", we can replace `TRUE` with `Returns(true)`
TRUE(x) = true

@noinline keyerror(key, K) = throw(ArgumentError("invalid key `$key` provided for pool key type $K"))
@noinline releaseerror() = throw(ArgumentError("cannot release when no objects are in use"))

# NOTE: assumes you have the lock!
function releasepermit(pool::Pool)
    pool.cur > 0 || releaseerror()
    pool.cur -= 1
    notify(pool.lock; all=false)
    return
end

"""
    acquire(f, pool::Pool{K, T}, [key::K]; forcenew::Bool=false, isvalid::Function) -> T

Get an object from a `pool`, optionally keyed by the provided `key`.
The provided function `f` must create a new object instance of type `T`.
Each `acquire` call MUST be matched by exactly one `release` call.
The `forcenew` keyword argument can be used to force the creation of a new object, ignoring any existing objects in the pool.
The `isvalid` keyword argument can be used to specify a function that will be called to determine if an object is still valid
for reuse. By default, all objects are considered valid.
If there are no objects available for reuse, `f` will be called to create a new object.
If the pool is already at its usage limit, `acquire` will block until an object is returned to the pool via `release`.
"""
function Base.acquire(f, pool::Pool{K, T}, key=nothing; forcenew::Bool=false, isvalid::Function=TRUE) where {K, T}
    key isa K || keyerror(key, K)
    Base.@lock pool.lock begin
        # first get a permit
        while pool.cur >= pool.limit
            wait(pool.lock)
        end
        pool.cur += 1
        try
            # now see if we can get an object from the pool for reuse
            if !forcenew
                objs = iskeyed(pool) ? get!(() -> safesizehint!(T[], pool.limit), pool.keyedvalues, key) : pool.values
                while !isempty(objs)
                    obj = pop!(objs)
                    isvalid(obj) && return obj
                end
            end
        catch
            # validation or pool lookup failed after taking a permit
            releasepermit(pool)
            rethrow()
        end
    end
    try
        # if there weren't any objects to reuse or we were forcenew, we'll create a new one
        return f()
    catch
        # if we error creating a new object, it's critical we return the permit to the pool
        Base.@lock pool.lock releasepermit(pool)
        rethrow()
    end
end

"""
    release(pool::Pool{K, T}, key::K, obj::Union{T, Nothing}=nothing)
    release(pool::Pool{K, T}, obj::T)
    release(pool::Pool{K, T})

Release an object from usage by a `pool`, optionally keyed by the provided `key`.
If `obj` is provided, it will be returned to the pool for reuse.
Otherwise, if `nothing` is returned, or `release(pool)` is called,
the usage count will be decremented without an object being returned to the pool for reuse.
"""
function Base.release(pool::Pool{K, T}, key, obj::Union{T, Nothing}=nothing) where {K, T}
    key isa K || keyerror(key, K)
    Base.@lock pool.lock begin
        # return the permit
        releasepermit(pool)
        # if we're given an object, we'll put it back in the pool
        if obj !== nothing
            # if an invalid key is provided, we let the KeyError propagate
            objs = iskeyed(pool) ? pool.keyedvalues[key] : pool.values
            push!(objs, obj)
        end
    end
    return
end

Base.release(pool::Pool{K, T}, obj::T) where {K, T} = release(pool, nothing, obj)
Base.release(pool::Pool{K, T}) where {K, T} = release(pool, nothing, nothing)

end # module

const WORK_QUEUE = Channel{Task}(0)
const WORKER_TASKS = Task[]

"""
  ConcurrentUtilities.@spawn expr
  ConcurrentUtilities.@spawn passthroughstorage::Bool expr

Similar to `Threads.@spawn`, schedule and execute a task (given by `expr`)
that will be run on a "background worker" (see [`ConcurrentUtilities.init`]((@ref))).

In the 2-argument invocation, `passthroughstorage` controls whether the task-local storage of the
`current_task()` should be "passed through" to the spawned task.
"""
macro spawn(thunk)
    esc(quote
        tsk = @task $thunk
        tsk.storage = current_task().storage
        put!($WORK_QUEUE, tsk)
        tsk
    end)
end

"""
  ConcurrentUtilities.@spawn expr
  ConcurrentUtilities.@spawn passthroughstorage::Bool expr

Similar to `Threads.@spawn`, schedule and execute a task (given by `expr`)
that will be run on a "background worker" (see [`ConcurrentUtilities.init`]((@ref))).

In the 2-argument invocation, `passthroughstorage` controls whether the task-local storage of the
`current_task()` should be "passed through" to the spawned task.
"""
macro spawn(passthroughstorage, thunk)
    esc(quote
        tsk = @task $thunk
        if $passthroughstorage
            tsk.storage = current_task().storage
        end
        put!($WORK_QUEUE, tsk)
        tsk
    end)
end

"""
  ConcurrentUtilities.init(nworkers=Threads.nthreads() - 1)

Initialize background workers that will execute tasks spawned via
[`ConcurrentUtilities.@spawn`](@ref). If `nworkers == 1`, a single worker
will be started on thread 1 where tasks will be executed in contention
with other thread 1 work. Background worker tasks can be inspected by
looking at `ConcurrentUtilities.WORKER_TASKS`.
"""
function init(nworkers=Threads.nthreads()-1)
    maxthreadid = nworkers + 1
    tids = Threads.nthreads() == 1 ? (1:1) : 2:maxthreadid
    resize!(WORKER_TASKS, max(nworkers, 1))
@static if VERSION < v"1.8.0"
    Threads.@threads for tid in 1:maxthreadid
        if tid in tids
            WORKER_TASKS[tid == 1 ? 1 : (tid - 1)] = Base.@async begin
                for task in WORK_QUEUE
                    schedule(task)
                    wait(task)
                end
            end
        end
    end
else
    Threads.@threads :static for tid in 1:maxthreadid
        if tid in tids
            WORKER_TASKS[tid == 1 ? 1 : (tid - 1)] = Base.@async begin
                for task in WORK_QUEUE
                    schedule(task)
                    wait(task)
                end
            end
        end
    end
end
    return
end

module ConcurrentUtilities

import Base: AbstractLock, islocked, trylock, lock, unlock
export Lockable, OrderedSynchronizer, reset!, ReadWriteLock, readlock, readunlock, @wkspawn,
    Workers, remote_eval, remote_fetch, Worker, terminate!, WorkerTerminatedException,
    Pool, acquire, release, drain!, try_with_timeout, TimeoutException, FIFOLock

macro samethreadpool_spawn(expr)
    if VERSION >= v"1.9.2"
        esc(:(Threads.@spawn Threads.threadpool() $expr))
    else
        esc(:(Threads.@spawn $expr))
    end
end

include("try_with_timeout.jl")
include("workers.jl")
using .Workers
isdefined(Base, :Lockable) ? (using Base: Lockable) : include("lockable.jl") # https://github.com/JuliaLang/julia/pull/52898
include("spawn.jl")
include("synchronizer.jl")
include("rwlock.jl")
include("pools.jl")
using .Pools
include("fifolock.jl")

function clear_current_task()
    current_task().storage = nothing
    current_task().code = nothing
    return
end

"""
    @wkspawn [:default|:interactive] expr

Create a `Task` and `schedule` it to run on any available
thread in the specified threadpool (`:default` if unspecified). The task is
allocated to a thread once one becomes available. To wait for the task to
finish, call `wait` on the result of this macro, or call
`fetch` to wait and then obtain its return value.

Values can be interpolated into `@wkspawn` via `\$`, which copies the value
directly into the constructed underlying closure. This allows you to insert
the _value_ of a variable, isolating the asynchronous code from changes to
the variable's value in the current task.
"""
macro wkspawn(args...)
    e = args[end]
    expr = quote
        try
            $e
        finally
            $(clear_current_task)()
        end
    end
@static if isdefined(Base.Threads, :maxthreadid)
    q = esc(:(Threads.@spawn $(args[1:end-1]...) $expr))
else
    q = esc(:(Threads.@spawn $expr))
end
    return q
end

end # module
